typedef struct textboxes TEXTBOXES;      
struct textboxes{
        int used;
	int x;
	int y;
	int x2;
	int y2;
	int pointer;
	int line;
	int maxlines;
	int curline;
	char *text;
	int win;
	BITMAP *bmp;
	int hasfocus;
};
TEXTBOXES textbox[MAXTEXTBOXES];
char buffer[100000];

int GetTextBoxPointer(int id)
{

	return textbox[id].pointer;
};

int SetTextBoxPointer(int id,int newpntr)
{
	textbox[id].pointer=newpntr;
};

int AddTextBox(int winid,int x,int y,int columns,int lines,char *textstring)
{
	int temp;
	int x2,y2;
	temp=0;
	do{
		temp=temp+1;
		if(textbox[temp].used==0)
		{
			textbox[temp].used=1;
			textbox[temp].x=x;
			textbox[temp].y=y;
			textbox[temp].x2=x+(columns*9);
			textbox[temp].y2=y+(lines*9)+2;
			textbox[temp].text=textstring;
			textbox[temp].pointer=0;
			textbox[temp].hasfocus=0;
			textbox[temp].line=1;
			textbox[temp].curline=1;
			textbox[temp].maxlines=lines;
			textbox[temp].win=winid;
			textbox[temp].bmp=create_bitmap(textbox[temp].x2-x,textbox[temp].y2-y);
			break;
		}
	}while(temp<MAXTEXTBOXES);
	//now draw the sucker
	x2=textbox[temp].x2-x;
	y2=textbox[temp].y2-y;
	rectfill(textbox[temp].bmp,0,0,x2,y2,guiwhite);
	rect(textbox[temp].bmp,0,0,x2,y2,0);
	line(textbox[temp].bmp,x2,0,x2,y2,guiwhite);
	line(textbox[temp].bmp,0,y2,x2,y2,guiwhite);
	blit(textbox[temp].bmp,guiwin[winid].bmp,0,0,x,y,x2,y2);
	return temp;
};

void RefreshTextBox(int boxid)
{
	int winid;
	int temp;
	int x,x2,y,y2;
	int pointer;
	int startline;
	int maxlines;
	int cnt;
	int linecount;
	int colcount;
	int tok;
        if(textbox[boxid].used!=1){return;}
        winid=textbox[boxid].win;
	temp=0;
        if(textbox[boxid].hasfocus==1)
	{
		x=textbox[boxid].x;
		y=textbox[boxid].y;
		x2=textbox[boxid].x2;
		y2=textbox[boxid].y2;
		pointer=textbox[boxid].pointer;
		startline=textbox[boxid].line;
		maxlines=textbox[boxid].maxlines;
		rectfill(textbox[boxid].bmp,0,0,x2,y2,guiwhite);
		rect(textbox[boxid].bmp,0,0,x2,y2,0);
		line(textbox[boxid].bmp,x2,0,x2,y2,guiwhite);
		line(textbox[boxid].bmp,0,y2,x2,y2,guiwhite);
		//now we do the text outputting FUN STUFF DUDE!!
		temp=1;
		cnt=0;
		linecount=1;
		colcount=1;
		do{
			
			tok=textbox[boxid].text[cnt];
			cnt=cnt+1;
			if(tok=='\n')
			{
				temp=temp+1;
					if(temp>startline)
					{
						linecount++;
						colcount=1;
					}
			}
			if(tok=='\t')
			{
				colcount=colcount+8;
			}
			if(tok==0){break;}
			if(linecount<maxlines+1 && temp>startline-1 && tok!='\r' && tok!='\n' && tok!='\t')
			{
				textprintf(textbox[boxid].bmp,SystemFont(),colcount*8,((linecount-1)*9)+2,0,&tok);
				if(cnt==textbox[boxid].pointer)
				{
					textprintf(textbox[boxid].bmp,SystemFont(),(colcount+1)*8,((linecount-1)*9)+2,guired,"_");
				}
				colcount=colcount+1;
			}
			else if(linecount<maxlines+1 && temp>startline-1)
			{
				if(cnt==textbox[boxid].pointer)
				{
					if(tok=='\r')
						textprintf(textbox[boxid].bmp,SystemFont(),8,((linecount-1)*9)+2,guired,"_");
					if(tok=='\n')
						textprintf(textbox[boxid].bmp,SystemFont(),8,((linecount-1)*9)+2,guired,"_");
					if(tok=='\t')
						textprintf(textbox[boxid].bmp,SystemFont(),(colcount)*8,((linecount-1)*9)+2,guired,"_");
				}
			}
		}while(linecount<maxlines+1);
		blit(textbox[boxid].bmp,guiwin[winid].bmp,0,0,x,y,x2,y2);
	}
};


void CheckAllTextBoxes(int winid)
{
	int mx;
	int my;
	int mb;
	int x,y,x2,y2;
	int temp;
	int temp2;
	int scan;
	int scancode;
	int pointer;
	int cnt;
	if(winid==0){return;}
	if(guiwin[winid].used!=1){return;}
	getmouse(&mx,&my,&mb);
	if(mb==1 && guiwin[winid].hasfocus==1)
	{
		temp=0;
		do{
			temp=temp+1;
                        if(textbox[temp].win==winid && textbox[temp].used==1)
			{
                                x=textbox[temp].x;
                                y=textbox[temp].y;
                                x2=textbox[temp].x2;
                                y2=textbox[temp].y2;
				x=x+guiwin[winid].x;
				y=y+guiwin[winid].y;
				x2=x2+guiwin[winid].x;
				y2=y2+guiwin[winid].y;
				if(mb==1 && mx>x && mx<x2 && my>y && my<y2)
				{
                                        textbox[temp].hasfocus=1;
                                        RefreshTextBox(temp);
				}
				else
				{
                                        textbox[temp].hasfocus=0;
                                        RefreshTextBox(temp);
				}
			}
                }while(temp<MAXTEXTBOXES);
		RefreshWin(winid);
		return;
	}

	temp=0;
	do{
		temp=temp+1;
                if(textbox[temp].hasfocus==1 && textbox[temp].win==winid)
		{
			if(key!=0)
			{
				scan=(key & 0xff);
				scancode=(key >> 8);
                                pointer=textbox[temp].pointer;
				if(scancode==KEY_HOME)
				{
					//move to begin of line
					pointer=textbox[temp].pointer;
					if(pointer==0)
						break;
					do{
						pointer--;
						if(textbox[temp].text[pointer]=='\r')
						{
							textbox[temp].pointer=pointer+1;
							break;
						}
						if(pointer==0)
						{
							textbox[temp].pointer=0;
							break;
						}
					}while(1);
					RefreshTextBox(temp);
					RefreshWin(winid);
					break;
				}
				if(scancode==KEY_END)
				{
					pointer=textbox[temp].pointer;
					if(textbox[temp].text[pointer]==0)
						break;
					if(textbox[temp].text[pointer]=='\n')
						break;
					do{
						pointer++;
						if(textbox[temp].text[pointer]=='\n')
						{
							textbox[temp].pointer=pointer;
							break;
						}
						if(textbox[temp].text[pointer]==0)
						{
							textbox[temp].pointer=pointer;
							break;
						}
					}while(1);
					RefreshTextBox(temp);
					RefreshWin(winid);
					break;
				}
				if(scancode==KEY_DOWN)
				{
					pointer=textbox[temp].pointer;
					if(textbox[temp].text[pointer]==0)
						break;
					do{
						pointer=pointer+1;
						if(textbox[temp].text[pointer]=='\n')
						{
							pointer=pointer+2;
							textbox[temp].pointer=pointer;
							textbox[temp].curline++;
							break;
						}
						if(textbox[temp].text[pointer]=='\r')
						{
							pointer=pointer+1;
							textbox[temp].pointer=pointer;
							textbox[temp].curline++;
							break;
						}

						if(textbox[temp].text[pointer]==0)
						{
							textbox[temp].pointer=pointer;
							break;
						}
					}while(1);
					//now find the newline position
					if((textbox[temp].curline-textbox[temp].line+1)>textbox[temp].maxlines)
					{
						textbox[temp].line++;
					}
					RefreshTextBox(temp);
					RefreshWin(winid);
					break;
				}
				if(scancode==KEY_UP)
				{
					pointer=textbox[temp].pointer;
					do{
						pointer=pointer-1;
						if(textbox[temp].text[pointer]=='\r')
						{
							pointer=pointer-1;
							textbox[temp].pointer=pointer;
							textbox[temp].curline--;
							break;
						}
						if(pointer<1)
						{
							textbox[temp].pointer=0;
							textbox[temp].curline=1;
							textbox[temp].line=1;
							break;
						}
					}while(1);
					if(textbox[temp].curline<1)
						textbox[temp].curline=1;
					if(textbox[temp].curline==textbox[temp].line)
						textbox[temp].line--;
					RefreshTextBox(temp);
					RefreshWin(winid);
					break;
				}
				if(scancode==KEY_LEFT)
				{
					if(textbox[temp].pointer==0)
						break;
					textbox[temp].pointer--;
					pointer=textbox[temp].pointer;
					if(textbox[temp].text[pointer]=='\r')
					{
						textbox[temp].pointer=textbox[temp].pointer-1;
						textbox[temp].curline--;
					}
					if(textbox[temp].curline<1)
						textbox[temp].curline=1;
					if(textbox[temp].curline<textbox[temp].line)
						textbox[temp].line--;
                                        RefreshTextBox(temp);
					RefreshWin(winid);
					break;
				}
				if(scancode==KEY_DEL)
				{
					pointer=textbox[temp].pointer;
					if(textbox[temp].text[pointer]=='\n')
					{
						strcpy(buffer,textbox[temp].text+pointer+2);
						strcpy(textbox[temp].text+pointer,buffer);
	                                        RefreshTextBox(temp);
						RefreshWin(winid);
						break;
					}
					strcpy(buffer,textbox[temp].text+pointer+1);
					strcpy(textbox[temp].text+pointer,buffer);
                                        RefreshTextBox(temp);
					RefreshWin(winid);
					break;
				}
				if(scancode==KEY_RIGHT)
				{
					if(textbox[temp].text[textbox[temp].pointer]==0)
						break;
					textbox[temp].pointer++;
					pointer=textbox[temp].pointer;
					if(textbox[temp].text[pointer]=='\r')
					{
						textbox[temp].pointer=textbox[temp].pointer+1;
						textbox[temp].curline++;
					}
					if((textbox[temp].curline-textbox[temp].line+2)>textbox[temp].maxlines)
					{
						textbox[temp].line++;
					}
                                        RefreshTextBox(temp);
					RefreshWin(winid);
					break;
				}
				if(scan==8 && pointer>0)//backspace
				{
					if(textbox[temp].pointer==0)
						break;
                                        textbox[temp].pointer=textbox[temp].pointer-1;
					pointer=textbox[temp].pointer;
					if(textbox[temp].text[pointer]!='\r')
					{
						strcpy(buffer,textbox[temp].text+pointer+1);
						strcpy(textbox[temp].text+pointer,buffer);
						textbox[temp].curline--;
					}
					else
					{
						textbox[temp].pointer=textbox[temp].pointer-1;
						pointer=pointer-1;
						strcpy(buffer,textbox[temp].text+pointer+2);
						strcpy(textbox[temp].text+pointer,buffer);
					}
					if(textbox[temp].curline<1)
						textbox[temp].curline=1;
					if(textbox[temp].curline==textbox[temp].line)
						textbox[temp].line--;

                                        RefreshTextBox(temp);
					RefreshWin(winid);
				}
				if(scan=='\r')
				{
					strcpy(buffer,textbox[temp].text+pointer);
					strcpy(textbox[temp].text+pointer+2,buffer);
					textbox[temp].text[pointer]='\n';
					textbox[temp].text[pointer+1]='\r';
					textbox[temp].pointer++;
					textbox[temp].pointer++;
					textbox[temp].curline++;
					if((textbox[temp].curline-textbox[temp].line+1)>textbox[temp].maxlines)
					{
						textbox[temp].line++;
					}
                                        RefreshTextBox(temp);
					RefreshWin(winid);
					break;
				}
				else if(scan!=8 && scan!='\n')
				{
					pointer=textbox[temp].pointer;
					strcpy(buffer,textbox[temp].text+pointer);
					strcpy(textbox[temp].text+pointer+1,&buffer);
                                        textbox[temp].text[pointer]=scan;
                                        textbox[temp].pointer=textbox[temp].pointer+1;
                                        RefreshTextBox(temp);
					RefreshWin(winid);
				}
			};
			break;
		}
        }while(temp<MAXTEXTBOXES);
};
