/* Sample Ikon Application

        This file was made for use with GCCFI (GCC For Ikon)

*/
#include <ikon.h>          /* ikon.h should ALWAYS be first */
#include <gui.h>

int ourwinid;           //id for our window
int sock;
int setwin;		//window for mail settings
int msgwin;		//window for composing messages
int emaillist;		//listbox for current messages
int emailbox;
int smtpbox;
int popbox;
int messagebox;
int userbox;
int passbox;
int subjectbox;
int popportbox;
int smtpportbox;
int tobox;
char email[50];
char smtp[100];
char pop[100];
char popport[10];
char smtpport[10];
char *message;
char username[30];
char password[30];
char toaddress[100];
char subject[100];
char emailsavepath[200];	//where to save an email message to
char settingsfile[100];	//file where user wants to load settings from
char auth[100];		//for encoding username and password to base64

void readmessage(char *msg);
char buff[200];	//transfer buffer
FILE *f1;

static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";
void encodeblock( unsigned char in[3], unsigned char out[4], int len )
{
    out[0] = cb64[ in[0] >> 2 ];
    out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
    out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
    out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

void encode( char *infile, char *outfile)
{
    unsigned char in[3], out[4];
	int pos;
	int outpos;
    int i, len, blocksout = 0;
	pos=0;
	outpos=0;
    while( pos<strlen(infile) ) {
        len = 0;
        for( i = 0; i < 3; i++ ) {
            in[i] = (unsigned char) infile[pos];
		if(in[i]=='#')
			in[i]=0;
		pos++;
            if( pos<=strlen(infile) ) {
                len++;
            }
            else {
                in[i] = 0;
            }
        }
        if( len ) {
            encodeblock( in, out, len );
            for( i = 0; i < 4; i++ ) {
		outfile[outpos]=out[i];
		outpos++;
            }
        }
    }
}

void *var_router(DCM *dcm, int function)
{
  return(0);
}

void clearinput()
{
	int temp;
	do{
		temp=socket_select(sock,100);
		if(temp>0)
		{
			temp=socket_recieve(sock,buff,90);
		}
		else
		{
			return;
		}
	}while(1);
}

void ExitHandler(int data)
{
        if(data==0)
        {       
		free((void *)message);
                CloseWin(ourwinid);
                ExitApp(pid);
        }

};

void closesettings(int data)
{
	CloseWin(setwin);
	SetFocusOn(ourwinid);
	RefreshWin(ourwinid);
}

void savesettings(int data)
{
	char *fbuff;
	f1=fopen("programs\\mailpro\\settings.ini","wt");
	fputs(email,f1);
	fputs("\n",f1);

	fputs(smtp,f1);
	fputs("\n",f1);

	fputs(pop,f1);
	fputs("\n",f1);

	fputs(username,f1);
	fputs("\n",f1);

	fputs(password,f1);
	fputs("\n",f1);

	fputs(popport,f1);
	fputs("\n",f1);
	
	fputs(smtpport,f1);
	fputs("\n",f1);

	fclose(f1);
	if(setwin!=0)
		closesettings(0);
}

void loadsettings2()
{
	char *fbuff;
	memset(email,0,sizeof(email));
	memset(smtp,0,sizeof(smtp));
	memset(pop,0,sizeof(pop));
	memset(username,0,sizeof(username));
	memset(password,0,sizeof(password));
	memset(popport,0,sizeof(popport));
	memset(smtpport,0,sizeof(smtpport));
	f1=fopen(settingsfile,"rt");
	fbuff=fgets(email,50,f1);
	email[strlen(email)-1]=0;

	fbuff=fgets(smtp,50,f1);
	smtp[strlen(smtp)-1]=0;

	fbuff=fgets(pop,50,f1);
	pop[strlen(pop)-1]=0;

	fbuff=fgets(username,50,f1);
	username[strlen(username)-1]=0;

	fbuff=fgets(password,50,f1);
	password[strlen(password)-1]=0;

	fbuff=fgets(popport,50,f1);
	popport[strlen(popport)-1]=0;

	fbuff=fgets(smtpport,50,f1);
	smtpport[strlen(smtpport)-1]=0;

	fclose(f1);

	RefreshEditBox(emailbox);
	RefreshEditBox(smtpbox);
	RefreshEditBox(popbox);
	RefreshEditBox(userbox);
	RefreshEditBox(passbox);
	RefreshEditBox(popportbox);
	RefreshEditBox(smtpportbox);
	RefreshWin(setwin);

}

void loadsettings(int data)
{
	memset(settingsfile,0,sizeof(settingsfile));
	FileSelector("*.*",loadsettings2,settingsfile);
}

void getsettings()
{
	BITMAP *bmp;
	int top;
	top=0-11;
	setwin=MakeWindow(10,30,300,350,"MailPro Settings",closesettings,0);
	bmp=GetWinBMP(setwin);
	textout(bmp,SystemFont(),"EMAIL ADDRESS:",3,37+top,0);
	emailbox=AddEditBox(setwin,3,55+top,290,email,0,0);
	textout(bmp,SystemFont(),"SMTP SERVER:",3,77+top,0);
	smtpbox=AddEditBox(setwin,3,95+top,290,smtp,0,0);
	textout(bmp,SystemFont(),"POP SERVER:",3,117+top,0);
	popbox=AddEditBox(setwin,3,135+top,290,pop,0,0);
	textout(bmp,SystemFont(),"USERNAME:",3,157+top,0);
	userbox=AddEditBox(setwin,3,175+top,290,username,0,0);
	textout(bmp,SystemFont(),"PASSWORD:",3,197+top,0);
	passbox=AddEditBox(setwin,3,215+top,290,password,0,0);
	textout(bmp,SystemFont(),"POP SERVER PORT:",3,237+top,0);
	popportbox=AddEditBox(setwin,3,255+top,290,popport,0,0);
	textout(bmp,SystemFont(),"SMTP SERVER PORT:",3,277+top,0);
	smtpportbox=AddEditBox(setwin,3,295+top,290,smtpport,0,0);

	MakeButton(setwin,3,315+top,"Load Settings",loadsettings,0);
	MakeButton(setwin,145,315+top,"Save Settings",savesettings,0);
	MakeButton(setwin,125,335+top,"Close",closesettings,0);
	RefreshEditBox(emailbox);
	RefreshEditBox(smtpbox);
	RefreshEditBox(popbox);
	RefreshEditBox(userbox);
	RefreshEditBox(passbox);
	RefreshEditBox(popportbox);
	RefreshEditBox(smtpportbox);
	SetFocusOn(setwin);
	RefreshWin(setwin);
}

int checkerror(char *str)
{
	if(strstr(str,"ERR")!=0)
		return 1;
	return 0;

}

void closeconnection()
{
	socket_send(sock,"QUIT\r\n",6);
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,50);
	strcat(message,buff);
	socket_close(sock);
}

void getmessage(char *str)
{
	int temp;
	FILE *out;
	char lastchar;
	char *tempn;
	int cnt;
	char ibuff[10];
	cnt=0;
	do{
		memset(buff,0,sizeof(buff));
		strcpy(buff,"programs\\mailpro\\");
		itoa(cnt,ibuff,10);
		strcat(buff,ibuff);
		strcat(buff,".eml");
		out=fopen(buff,"r");
		if(out==0)
		{
			break;
		}
		else
		{
			fclose(out);
		}
		cnt++;
	}while(1);
	out=fopen(buff,"wt");
	memset(buff,0,sizeof(buff));
	strcpy(buff,"RETR ");
	strcat(buff,str);
	strcat(buff,"\r\n");
	socket_send(sock,buff,strlen(buff));
	do{
		temp=socket_recieve(sock,buff,1);
		if(buff[0]=='\n')
			break;
	}while(1);
	lastchar=0;
	do{
		memset(buff,0,sizeof(buff));
		temp=socket_recieve(sock,buff,1);
		fputc(buff[0],out);
		if(buff[0]=='.' && lastchar=='\n')
		{
			socket_recieve(sock,buff,1);
			if(buff[0]=='\r')
				break;
			fputc(buff[0],out);
			
		}
		lastchar=buff[0];
	}while(1);
	//fflush(out);
	fclose(out);
	//clearinput();
	socket_recieve(sock,buff,90);
	memset(buff,0,sizeof(buff));
	strcpy(buff,"DELE ");
	strcat(buff,str);
	strcat(buff,"\r\n");
	socket_send(sock,buff,strlen(buff));
	memset(buff,0,sizeof(buff));
	temp=socket_recieve(sock,buff,90);
}

void refreshmaillist()
{
	struct ffblk f;
	int done;
	ResetListBox(emaillist);
	done=findfirst("programs\\mailpro\\*.eml",&f,FA_SYSTEM);
	while(!done)
	{
		AddListItem(emaillist,f.ff_name);
		done=findnext(&f);
	}
	RefreshListBox(emaillist);
}

void checkmail()
{
	int temp;
	char *s;
	char mchar[10];
	int totalmessages;
	int cnt;
	sock=socket_open();
	temp=socket_connect(sock,pop,atoi(popport));
	if(temp!=0)
		return;
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,50);


	memset(buff,0,sizeof(buff));
	strcpy(buff,"USER ");
	strcat(buff,username);
	strcat(buff,"\r\n");
	socket_send(sock,buff,strlen(buff));
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,50);
	if(checkerror(buff)==1)
	{
		closeconnection();
		return;
	}

	memset(buff,0,sizeof(buff));
	strcpy(buff,"PASS ");
	strcat(buff,password);
	strcat(buff,"\r\n");
	socket_send(sock,buff,strlen(buff));
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,50);
	if(checkerror(buff)==1)
	{
		closeconnection();
		return;
	}


	memset(buff,0,sizeof(buff));
	strcpy(buff,"STAT");
	strcat(buff,"\r\n");
	socket_send(sock,buff,strlen(buff));
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,90);
	if(buff[4]=='0')
	{
		strcat(message,"\nNo messages!");
		closeconnection();
		return;
	}
	else
	{
		//we have some mail to download
		totalmessages=atoi(buff+4);
		memset(buff,0,sizeof(buff));
		sprintf(buff,"%d messages",totalmessages);
		SystemMessage(buff);
		cnt=1;
		do{
			memset(mchar,0,sizeof(mchar));
			itoa(cnt,mchar,10);
			getmessage(mchar);
			cnt++;
			if(cnt>totalmessages)
				break;
		}while(1);
	}
	closeconnection();
	refreshmaillist();
	RefreshWin(ourwinid);	
}

void sendmessage2()
{
	int temp;
	char *s;
	char mchar[10];
	int totalmessages;
	int cnt;

	sock=socket_open();
	temp=socket_connect(sock,smtp,atoi(smtpport));
	if(temp!=0)
	{
		temp=socket_connect(sock,smtp,2525);
		if(temp!=0)
		{
			SystemMessage("\r\n\tUnable to connect\r\n\tto server!");
			return;
		}
	}
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,50);

	memset(buff,0,sizeof(buff));
	strcpy(buff,"EHLO mail.boehringer.ca\r\n");
	socket_send(sock,buff,strlen(buff));
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,100);
	//now check if it supports auth
	strupr(buff);
	if(strstr(buff,"AUTH")!=0 && strstr(buff,"PLAIN")!=0)
	{
		//we need to send the AUTH command
		memset(buff,0,sizeof(buff));
		memset(auth,0,sizeof(auth));
		strcpy(buff,"#");
		strcat(buff,username);
		strcat(buff,"#");
		strcat(buff,password);
		encode(buff,auth);
		memset(buff,0,sizeof(buff));
		strcpy(buff,"AUTH PLAIN ");
		strcat(buff,auth);
		strcat(buff,"\r\n");
		socket_send(sock,buff,strlen(buff));
		memset(buff,0,sizeof(buff));
		socket_recieve(sock,buff,100);
		strupr(buff);
		if(strstr(buff,"FAILED")!=0)
		{
			closeconnection();
			SystemMessage("AUTH PLAIN:\r\nAuthorization failed!");
			return;
		}
	}
	else if (strstr(buff,"AUTH")!=0 && strstr(buff,"PLAIN")==0)
	{
		memset(buff,0,sizeof(buff));
		memset(auth,0,sizeof(auth));
		encode(username,auth);
		strcpy(buff,"AUTH LOGIN\r\n");
		socket_send(sock,buff,strlen(buff));
		memset(buff,0,sizeof(buff));
		socket_recieve(sock,buff,100);
		memset(buff,0,sizeof(buff));
		strcpy(buff,auth);
		strcat(buff,"\r\n");
		socket_send(sock,buff,strlen(buff));
		socket_recieve(sock,buff,100);
		memset(buff,0,sizeof(buff));
		memset(auth,0,sizeof(auth));
		encode(password,auth);
		strcpy(buff,auth);
		strcat(buff,"\r\n");
		socket_send(sock,buff,strlen(buff));
		memset(buff,0,sizeof(buff));
		socket_recieve(sock,buff,100);
		strupr(buff);
		if(strstr(buff,"FAILED")!=0)
		{
			closeconnection();
			SystemMessage("AUTH LOGIN:\r\nAuthorization failed!");
			return;
		}
	}
	else{
		memset(buff,0,sizeof(buff));
		strcpy(buff,"HELO mail.boehringer.ca\r\n");
		socket_send(sock,buff,strlen(buff));
		memset(buff,0,sizeof(buff));
		socket_recieve(sock,buff,100);
	}

	memset(buff,0,sizeof(buff));
	strcpy(buff,"MAIL FROM:<");
	strcat(buff,email);
	strcat(buff,">");
	strcat(buff,"\r\n");
	socket_send(sock,buff,strlen(buff));
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,100);


	memset(buff,0,sizeof(buff));
	strcpy(buff,"RCPT TO:<");
	strcat(buff,toaddress);
	strcat(buff,">\r\n");
	socket_send(sock,buff,strlen(buff));
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,100);

	memset(buff,0,sizeof(buff));
	strcpy(buff,"DATA");
	strcat(buff,"\r\n");
	socket_send(sock,buff,strlen(buff));
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,100);

	memset(buff,0,sizeof(buff));
	strcpy(buff,"From: ");
	strcat(buff,email);
	strcat(buff,"\r\nTo: ");
	strcat(buff,toaddress);
	strcat(buff,"\r\nSubject: ");
	strcat(buff,subject);
	strcat(buff,"\r\n\r\n");
	socket_send(sock,buff,strlen(buff));
	socket_send(sock,message,strlen(message));
	memset(buff,0,sizeof(buff));
	socket_send(sock,"\r\n\r\n.\r\n",7);
	memset(buff,0,sizeof(buff));
	socket_recieve(sock,buff,100);
	
	closeconnection();
	SystemMessage("\r\n\tMessage Sent!");
	RefreshWin(msgwin);
}

void closemsg(int data)
{
	CloseWin(msgwin);
	RefreshWin(ourwinid);
	msgwin=0;
}

void sendmessage()
{
	BITMAP *bmp;
	int top;
	if(msgwin!=0)
		return;
	top=0-11;
	msgwin=MakeWindow(10,30,700,500,"Send Message",closemsg,0);
	bmp=GetWinBMP(msgwin);
	memset(toaddress,0,sizeof(toaddress));
	memset(message,0,200000);
	memset(subject,0,sizeof(subject));
	textout(bmp,SystemFont(),"TO:",3,37+top,0);
	tobox=AddEditBox(msgwin,3,55+top,400,toaddress,0,0);
	textout(bmp,SystemFont(),"SUBJECT:",3,77+top,0);
	subjectbox=AddEditBox(msgwin,3,95+top,400,subject,0,0);
	textout(bmp,SystemFont(),"MESSAGE:",3,117+top,0);
	messagebox=AddTextBox(msgwin,3,135+top,69,23,message);
	MakeButton(msgwin,3,470+top,"Send Message",sendmessage2,0);
	MakeButton(msgwin,135,470+top,"Close",closemsg,0);
	SetFocusOn(msgwin);
	RefreshWin(msgwin);
}

void replymessage2()
{
	BITMAP *bmp;
	int top;
	if(msgwin!=0)
		return;
	top=0-11;
	msgwin=MakeWindow(10,30,700,500,"Send Reply",closemsg,0);
	bmp=GetWinBMP(msgwin);
	textout(bmp,SystemFont(),"TO:",3,37+top,0);
	tobox=AddEditBox(msgwin,3,55+top,400,toaddress,0,0);
	textout(bmp,SystemFont(),"SUBJECT:",3,77+top,0);
	subjectbox=AddEditBox(msgwin,3,95+top,400,subject,0,0);
	textout(bmp,SystemFont(),"MESSAGE:",3,117+top,0);
	messagebox=AddTextBox(msgwin,3,135+top,69,23,message);
	MakeButton(msgwin,3,470+top,"Send Message",sendmessage2,0);
	MakeButton(msgwin,135,470+top,"Close",closemsg,0);
	RefreshTextBox(messagebox);
	RefreshEditBox(tobox);
	RefreshEditBox(subjectbox);
	SetFocusOn(msgwin);
	RefreshWin(msgwin);
}


void replymessage(int data)
{
	CloseWin(msgwin);
	msgwin=0;
	replymessage2();
}

void readmessage(char *msg)
{
	BITMAP *bmp;
	char buff[202];
	FILE *eml;
	int top;
	int start;
	int hasbracket;
	int end;
	int cnt;
	int offset;
	if(msgwin!=0)
		return;
	top=0-11;
	//lets parse the .eml file for the necessary info
	memset(toaddress,0,sizeof(toaddress));
	memset(message,0,200000);
	memset(subject,0,sizeof(subject));
	strcpy(buff,"programs/mailpro/");
	strcat(buff,msg);
	eml=fopen(buff,"r");
	start=0;
	end=0;
	hasbracket=0;
	do{
		memset(buff,0,202);
		if(fgets(buff,200,eml)==0)
			break;
		if(strncmp(buff,"From:",5)==0)
		{
			start=6;
			cnt=0;
			do{
				if(buff[cnt]=='<')
				{
					start=cnt+1;
					hasbracket=1;
					break;
				}
				if(buff[cnt]==0)
				{
					break;
				}
				cnt++;
			}while(1);
			do{
				if(buff[cnt]=='>' && hasbracket==1)
				{
					end=cnt-start;
					strncpy(toaddress,buff+start,end);
					break;
				}
				if(buff[cnt]==0 && hasbracket==0)
				{
					end=cnt-start-2;
					strncpy(toaddress,buff+start,end);
					break;
				}
				else if(buff[cnt]==0)
				{
					strcpy(toaddress,"Error");
					break;
				}
				cnt++;
			}while(1);
		}
		if(strncmp(buff,"Subject:",8)==0)
		{
			strncpy(subject,buff+9,strlen(buff)-11);
		}
		if(buff[0]==0x0a || buff[0]==0x0d)
		{
			offset=0;
			do{
				if(fread(message+offset,1,200,eml)!=200)
					break;
				offset+=200;
				if(offset==200000-200)
					break;
			}while(1);
			break;
		}
	}while(1);
	fclose(eml);
	cnt=200000-1;
	do{
		if(message[cnt]=='.')
		{
			message[cnt]=0;
			break;
		}
		cnt--;
		if(cnt==0)
			break;
	}while(1);
	//lets display everything
	msgwin=MakeWindow(25,30,700,500,"Read Message",closemsg,0);
	bmp=GetWinBMP(msgwin);
	textout(bmp,SystemFont(),"From:",3,37+top,0);
	tobox=AddEditBox(msgwin,3,55+top,400,toaddress,0,0);
	textout(bmp,SystemFont(),"SUBJECT:",3,77+top,0);
	subjectbox=AddEditBox(msgwin,3,95+top,400,subject,0,0);
	textout(bmp,SystemFont(),"MESSAGE:",3,117+top,0);
	messagebox=AddTextBox(msgwin,3,135+top,69,23,message);
	MakeButton(msgwin,10,470+top,"Reply",replymessage,0);
	MakeButton(msgwin,135,470+top,"Close",closemsg,0);
	RefreshTextBox(messagebox);
	RefreshEditBox(tobox);
	RefreshEditBox(subjectbox);
	SetFocusOn(msgwin);
	RefreshWin(msgwin);
}

void clickmenu(int option)
{
	if(option==1)
		getsettings();
	if(option==2)
		checkmail();
	if(option==3)
		sendmessage();

}

void domenu(int data)
{
	PopMenu("Mail Settings,none,Check Mail,none,Send Message,none",clickmenu);
};

void saveemail()
{
	copyfile(GetListBoxSelection(emaillist),emailsavepath);
	RefreshWin(ourwinid);
}

void listmenu(int data)
{
	char buff[200];
	memset(buff,0,sizeof(buff));
	if(data==1)
	{
		//read message
		strcpy(buff,GetListBoxSelection(emaillist));
		readmessage(buff);
	}
	if(data==2)
	{
		//delete message
		strcpy(buff,"programs\\mailpro\\");
		strcat(buff,GetListBoxSelection(emaillist));
		remove(buff);
		refreshmaillist();
		RefreshListBox(emaillist);
		RefreshWin(ourwinid);

	}
	if(data==3)
	{
		//save the message somewhere else
		FileSelector(GetPath(pid),saveemail,emailsavepath);
	}
}

void listclick(int data)
{
	char buff[200];
	int mb;
	mb=GetLastMouseB();
	if(mb==2)
	{
		PopMenu("Read Message,none,Delete,none,Save As,none",listmenu);
		return;
	}
	memset(buff,0,sizeof(buff));
	strcpy(buff,GetListBoxSelection(emaillist));
	readmessage(buff);
}

static void appmain()
{
  //*********[ Your main program routine ]****************
        InitGUI();
        ourwinid=MakeWindow(10,30,500,500,"MailPro 0.2",ExitHandler,0);
	MakeLabelButton(ourwinid,SystemFont(),3,24,0,"File",domenu,0);
        emaillist=AddListBox(ourwinid,2,40,44,30,listclick,0);
	message=(char *)malloc(200000);
        //AddListItem(temp2,"hello;world");
        //sock=socket_open();
        //socket_connect(sock,"www.yahoo.com",80);
        //socket_close(sock);
        //RefreshListBox(temp2);
	f1=fopen("programs\\mailpro\\settings.ini","rt");
	if(f1)
	{
		fclose(f1);
		strcpy(settingsfile,"programs\\mailpro\\settings.ini");
		loadsettings2();
	}
	refreshmaillist();	
        RefreshWin(ourwinid);
	msgwin=0;
};



